#include <stdio.h>

#include <VRS51L3074_SDCC.h>

#include "lowlevel.h"
#include "highlevel.h"
#include "highlevel_text.h"





float rand(void)
{
static unsigned long idum;
unsigned long itemp;
const static unsigned long jflone = 0x3f800000;
const static unsigned long jflmsk = 0x007fffff;

idum = 1664525L*idum + 1013904223L;
itemp = jflone | (jflmsk & idum);
return((*(float *)&itemp)-1.0);
}

//;-------------------------------------------------------------------
//;- DELAY1MSTO : 1MS DELAY USING TIMER0
//; CALIBRATED FOR 40MHZ
//;-------------------------------------------------------------------
void delay(unsigned int dlais){
idata unsigned char x=0;
idata unsigned int dlaisloop;
x = PERIPHEN1; //LOAD PERIPHEN1 REG
x |= 0x01; //ENABLE TIMER 0
PERIPHEN1 = x;
dlaisloop = dlais;
while ( dlaisloop > 0)
{
TH0 = 0x63; //TIMER0 RELOAD VALUE FOR 1MS AT 40MHZ
TL0 = 0xC0;
T0T1CLKCFG = 0x00; //NO PRESCALER FOR TIMER 0 CLOCK
T0CON = 0x04; //START TIMER 0, COUNT UP
do{
x=T0CON;
x= x & 0x80;
}while(x==0);
T0CON = 0x00; //Stop Timer 0
dlaisloop = dlaisloop-1;
}//end of while dlais...
x = PERIPHEN1; //LOAD PERIPHEN1 REG
x = x & 0xFE; //DISABLEBLE TIMER 0
PERIPHEN1 = x;
}//End of function delais

#define MsDelay(a) delay(a)

/* MAIN PROGRAM */

main()
{
int i;
char numero[6];
float num,prom,vcc,sum;

	LCD_init();
	while(1){
		LCD_clear();
		LCD_print6at(0,0,"Texto en 6x8, 20 cpl");
		LCD_print8at(2,0,0,"Texto 8x8, 16cpl");
		LCD_print8at(4,0,'B',"Texto 8x16,16cpl");
		MsDelay (5000);
		LCD_clear();
		LCD_print6at(1,0,"El texto en 6x8 es  ideal para mostrar  dialogos cortos");
		LCD_rectangle(0,0,120,40);
		MsDelay (5000);
		LCD_clear();
		LCD_print8at(1,0,0,"El texto en 8x8 resalta valores de variables:");
		LCD_print6at(7,0,"Corriente:        mA");
		LCD_print8at(7,9,0,"12,3");
		MsDelay (5000);
		LCD_clear();
		LCD_print8at(1,0,'B',"El formato 8x16 resulta ideal ennumeros");
		MsDelay (5000);
		LCD_clear();
		LCD_print6at(0,4,"Caudalimetro");
		LCD_line(26,8,98,8);
		LCD_print6at(2,0,"Caudal:        m3/hr");
		LCD_print6at(5,0," Qprom:        m3/hr");
		LCD_print6at(7,0,"  Alim:        V");
		num=110.0;
		vcc=5.0;
		sum=0;
		for(i=1;i<41;i++) {
			num+=(rand()-0.5)/10;
			sum+=num;
			prom=sum/i;
			sprintf(numero,"%d.%d",(int)num,((int)(10.0*num))%10);
			LCD_print8at(2,6,'B',numero);
			sprintf(numero,"%d.%d",(int)prom,((int)(10.0*prom))%10);
			LCD_print8at(5,6,0,numero);
			vcc+=(rand()-0.5)/100;
			sprintf(numero,"%d.%02d",(int)vcc,((int)(100.0*vcc))%100);
			LCD_print8at(7,7,0,numero);
			MsDelay (500);
		}
	}
}
